var _g_MAIN_DOCUMENT_NAME;

var _g_reports = new Array();

var _g_reportsWindowWidth = 800;
var _g_reportsWindowHeight = 600;

// @see http://www.howtocreate.co.uk/tutorials/javascript/browserwindow
function windowWidth() {
	var width = 0;
	if( typeof( window.innerWidth ) == 'number' ) {
		//Non-IE
		width = window.innerWidth;
	} else if( document.documentElement && document.documentElement.clientWidth ) {
		//IE 6+ in 'standards compliant mode'
		width = document.documentElement.clientWidth;
	} else if( document.body && document.body.clientWidth ) {
		//IE 4 compatible
		width = document.body.clientWidth;
	}
	return width;
}
// @see http://www.howtocreate.co.uk/tutorials/javascript/browserwindow
function windowHeight() {
	var height = 0;
	if( typeof( window.innerWidth ) == 'number' ) {
		//Non-IE
		height = window.innerHeight;
	} else if( document.documentElement && document.documentElement.clientHeight ) {
		//IE 6+ in 'standards compliant mode'
		height = document.documentElement.clientHeight;
	} else if( document.body && document.body.clientHeight ) {
		//IE 4 compatible
		height = document.body.clientHeight;
	}
	return height;
}
function initRSM(mainDocName) {
	_g_MAIN_DOCUMENT_NAME = mainDocName;

    registerApplicationListeners();
}
function registerApplicationListeners() {
    try {
    
        // Firefox & Safari
        if (window.addEventListener) {
         
            window.addEventListener("unload", onApplicationUnload, false);
            window.addEventListener("resize", onApplicationResize, false);
        // Internet Explorer
        } else if (window.attachEvent) {
    
            window.attachEvent("onunload", onApplicationUnload);
            window.attachEvent("onresize", onApplicationResize);
            
        } else {
        
            window.unload = onApplicationUnload;
            window.resize = onApplicationResize; 
        }    
    }
    catch(e) {
        alert("Unable to register application unload event listener.");
    }
}
function onApplicationResize() {
	if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
		document.getElementById(_g_MAIN_DOCUMENT_NAME).width = windowWidth();
		document.getElementById(_g_MAIN_DOCUMENT_NAME).height = windowHeight();
	}
}
function onApplicationUnload() {
    // dispose application synchronously
    if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null
    	&& document.getElementById(_g_MAIN_DOCUMENT_NAME).dispose != null) {
	    document.getElementById(_g_MAIN_DOCUMENT_NAME).dispose(false);
    }
}

/**
 * Sends an Ajax/XML-HTTP request.
 *
 * @param requestType (String) The HTTP method used to open the connection: 
 *        such as GET, POST, or HEAD
 * @param url (String) The absolute or a relative URL of the XML data or 
 *        server-side XML Web services.
 * @param async (Boolean) true for asynchronous operation (the call returns 
 *        immediately), or false for synchronous operation.
 * @param headers (Object) Hash of name-value pairs representing custom HTTP
 *        headers to add to the request.
 */
function sendAjaxRequest(requestType, url, async, headers) { 
    var xhr;
    
    try {
        // IE7, Mozilla, Safari, etc: Use native object
        xhr = new XMLHttpRequest();
    }
    catch (e) {
        try { 
            // Use the ActiveX control for IE5.x and IE6
            xhr = new ActiveXObject('Msxml2.XMLHTTP');                                      
        } 
        catch (e) {  
            try { 
                // Alternate implementation
                xhr = new ActiveXObject('Microsoft.XMLHTTP');  
            } 
            catch (e) {  
                xhr = null;  
            }              
        } 
    } 
    
    if (xhr != null) {  
        try { 
            xhr.open(requestType, url, async); 
            for (var name in headers) {
                var value = headers[name];
                xhr.setRequestHeader(name, value);
            } 
            xhr.send(); 
            return xhr.responseText;             
        } 
        catch (e) {  
            //alert("XMLHttpRequest error: " + e.message); 
        }          
    }
    else {
        alert("XMLHttpRequest not supported.");    
    } 
}
function openReportsWindow(src) {
	// show in full screen mode?
	var popupWidth = _g_reportsWindowWidth;
	var popupHeight = _g_reportsWindowHeight;

	// show centered
	var x = (screen.availWidth - popupWidth) / 2;
	var y = (screen.availHeight - popupHeight) / 2;

	// @see http://devguru.com/technologies/javascript/11485.asp
	try {
		// @see http://devguru.com/technologies/javascript/10894.asp
	    _g_reports[src] = window.open(src, "_blank", 
    	    "x="+x+",y="+y+",width="+popupWidth+",height="+popupHeight+",dependent=yes,resizable=yes,status=no,toolbar=no,menubar=no,location=no,scrollbars=yes,directories=no");
    	
    	if (_g_reports[src]==null) return;
    	
    	_g_reports[src].focus();

		// Firefox & Safari
    	if (_g_reports[src].addEventListener) {
			this.addEventListener('unload', function() {closeReportsWindow(src)}, false);

		// internet explorer
    	} else if (_g_reports[src].attachEvent) {
			this.attachEvent('onunload', function() {closeReportsWindow(src)});
      	} else {
	    	this.onunload = function() {
	    		closeReportsWindow(src);
	    	};
    	}
    } catch (err) {
    	alert('ERROR: was not able to open reports window'+"\n\n"+err.message);
    }
}
function closeReportsWindow(src) {
	if (_g_reports[src]) {
		if (! _g_reports[src].closed) {
			_g_reports[src].close();
		}
	}
}
// @see http://blog.flexexamples.com/2008/03/11/returning-values-from-javascript-in-your-flex-applications-using-the-externalinterface-api/
function getNavigatorObject(keys) {
    var hash = {};
    var len = keys.length;
    for (var i=0; i<len; i++) {
        var key = keys[i];
        var value = navigator[key];
        hash[key] = value;
    }

    return hash;
}

var _g_changeList = new Hash();

/**
 * This function is called to indicate that a planogram has edit changes
 * and the we should do "unbeforeunload" processing for said planogram.
 */
 
function registerChanged(moniker)
{
	try
	{
 		_g_changeList.setItem(moniker,"X");
 		/*
 		alert(_g_changeList.getItem(moniker));
 		*/
 	    window.onbeforeunload=confirmExit;
 	}
 	catch(err)
 	{
 		/*alert(err.message);*/
 	}
 		
}

/**
 * This function is called to indicate that a planogram has no further edit
 * changes and the we should do no "unbeforeunload" processing for said planogram.
 */
 
function unRegisterChanged(moniker)
{
	try
	{
 		_g_changeList.removeItem(moniker);
 	
 		if (_g_changeList.length==0) 
 			window.onbeforeunload=null;
 			
 		/*
 		alert(_g_changeList.getItem(moniker));
 		*/
 		
 	}
 	catch(err)
 	{
 		/*alert(err.message);*/
 	}
}


function Hash()
{
	this.length = 0;
	this.items = new Array();
	for (var i = 0; i < arguments.length; i += 2) {
		if (typeof(arguments[i + 1]) != 'undefined') {
			this.items[arguments[i]] = arguments[i + 1];
			this.length++;
		}
	}
   
	this.removeItem = function(in_key)
	{
		var tmp_previous;
		if (typeof(this.items[in_key]) != 'undefined') {
			this.length--;
			var tmp_previous = this.items[in_key];
			delete this.items[in_key];
		}
	   
		return tmp_previous;
	}

	this.getItem = function(in_key) {
		return this.items[in_key];
	}

	this.setItem = function(in_key, in_value)
	{
		var tmp_previous;
		if (typeof(in_value) != 'undefined') {
			if (typeof(this.items[in_key]) == 'undefined') {
				this.length++;
			}
			else {
				tmp_previous = this.items[in_key];
			}

			this.items[in_key] = in_value;
		}
	   
		return tmp_previous;
	}

	this.hasItem = function(in_key)
	{
		return typeof(this.items[in_key]) != 'undefined';
	}

	this.clear = function()
	{
		for (var i in this.items) {
			delete this.items[i];
		}

		this.length = 0;
	}
}

var g_msg="You may have unsaved changes. Are you sure you want to close the application?";

/**
 * Set the browser status line.
*/

function setBrowserStatusLine(message)
{
	window.status=message;
}

/**
 * Register the close message for exit confirmation.
*/

function registerCloseMessage(message)
{
	g_msg=message;
}

function confirmExit()
{
	return g_msg;
}

function downloadDocument(url)
{
	window.open(url,'','width=1,height=1');
}

function getBrowserCPU()
{
	try
	{
		return window.navigator.cpuClass;
	}
	catch(err)
	{
	}
	return "";	
}

function getBrowserType()
{
	if (navigator.userAgent.indexOf("MSIE") != -1) return 'MSIE';
	else return 'OTHER';
}

function evalExpression(expr)
{
	return eval(expr);
}