DROP TRIGGER maxdata.tr_lv7loc_aft_d
@

CREATE TRIGGER maxdata.tr_lv7loc_aft_d
AFTER DELETE ON maxdata.lv7loc
REFERENCING OLD AS OLD
FOR EACH ROW
MODE DB2SQL
BEGIN ATOMIC

/*
---------------------------------------------------------------------------------------------------
Revision 2.1.0.0  2012/07/09 for S0824486
moved deleting of temp lv9mast records to RSM Server startup

Revision 2.0.0.0  2011/08/03 for S0778359
add logic to update fixture_type_id = -2 (aka 'Deleted Fixture Type') when Fixture Type Planogram is deleted

Revision 1.1.2.4  2009/09/23 20:00:43  makirk
Undoing fix for S0476933

Revision 1.1.2.2  2009/07/20 18:59:45  makirk
FIXID S0595519: Semicolon following final "END" has been removed

Revision 1.1.2.1  2009/05/06 18:48:26  makirk
Initial porting from space optm

---------------------------------------------------------------------------------------------------
*/

-- "FOR EACH ROW" will fire for each row affected so this can replace the cursor used in the SS version

DECLARE t_cnt           INTEGER;
DECLARE n_sqlnum        INTEGER;
DECLARE t_error_msg     VARCHAR(255);
DECLARE t_fix_type_id   INTEGER;

SET n_sqlnum = 1000;

--following logic moved from tr_fixture_type_lkup_aft_d
--this must happen before corresponding record is deleted from maxdata.fixture_type_lkup
IF (OLD.fixture_type_id = -1) THEN
        SET t_fix_type_id = (SELECT fixture_type_id FROM maxdata.fixture_type_lkup WHERE lv7loc_id = OLD.lv7loc_id);

        SET n_sqlnum = 1010;
        UPDATE maxdata.lv7loc
           SET fixture_type_id = -2
         WHERE fixture_type_id = t_fix_type_id;

        SET n_sqlnum = 1020;
        DELETE FROM maxdata.fixture_type_lkup WHERE lv7loc_id = OLD.lv7loc_id;
END IF;

SET n_sqlnum = 1100;
IF NVL(OLD.lv1loc_id,0) <> -2 THEN
        -- Checking if the table auto_segment exists first (for databases that don't have automation yet)
        SET t_cnt = 0;

        SET n_sqlnum = 1200;
        SET t_cnt=(SELECT COUNT(*)
                     FROM syscat.tables
                    WHERE tabname = 'AUTO_SEGMENT');

        IF (t_cnt = 1) THEN
                SET n_sqlnum = 1300;

                DELETE FROM maxdata.auto_segment
                 WHERE lv7loc_id = OLD.lv7loc_id
                   AND OLD.record_type IN ('M','T','C','D');
        END IF;

END IF;

END
@